/* Icon Picker */
(function($) {
	$.fn.iconPicker = function( options ) {
		var options = ['dashicons','dashicons']; // default font set
		var icons;
		$list = $('');
		function font_set() {
			if (options[0] == 'dashicons') {
				icons = [
					"blank",	// there is no "blank" but we need the option
					"menu",
					"admin-site",
					"dashboard",
					"admin-media",
					"admin-page",
					"admin-comments",
					"admin-appearance",
					"admin-plugins",
					"admin-users",
					"admin-tools",
					"admin-settings",
					"admin-network",
					"admin-generic",
					"admin-home",
					"admin-collapse",
					"admin-links",
					"format-links",
					"admin-post",
					"format-standard",
					"format-image",
					"format-gallery",
					"format-audio",
					"format-video",
					"format-chat",
					"format-status",
					"format-aside",
					"format-quote",
					"welcome-write-blog",
					"welcome-edit-page",
					"welcome-add-page",
					"welcome-view-site",
					"welcome-widgets-menus",
					"welcome-comments",
					"welcome-learn-more",
					"image-crop",
					"image-rotate-left",
					"image-rotate-right",
					"image-flip-vertical",
					"image-flip-horizontal",
					"undo",
					"redo",
					"editor-bold",
					"editor-italic",
					"editor-ul",
					"editor-ol",
					"editor-quote",
					"editor-alignleft",
					"editor-aligncenter",
					"editor-alignright",
					"editor-insertmore",
					"editor-spellcheck",
					"editor-distractionfree",
					"editor-kitchensink",
					"editor-underline",
					"editor-justify",
					"editor-textcolor",
					"editor-paste-word",
					"editor-paste-text",
					"editor-removeformatting",
					"editor-video",
					"editor-customchar",
					"editor-outdent",
					"editor-indent",
					"editor-help",
					"editor-strikethrough",
					"editor-unlink",
					"editor-rtl",
					"align-left",
					"align-right",
					"align-center",
					"align-none",
					"lock",
					"calendar",
					"visibility",
					"post-status",
					"post-trash",
					"edit",
					"trash",
					"arrow-up",
					"arrow-down",
					"arrow-left",
					"arrow-right",
					"arrow-up-alt",
					"arrow-down-alt",
					"arrow-left-alt",
					"arrow-right-alt",
					"arrow-up-alt2",
					"arrow-down-alt2",
					"arrow-left-alt2",
					"arrow-right-alt2",
					"leftright",
					"sort",
					"list-view",
					"exerpt-view",
					"share",
					"share1",
					"share-alt",
					"share-alt2",
					"twitter",
					"rss",
					"facebook",
					"facebook-alt",
					"networking",
					"googleplus",
					"hammer",
					"art",
					"migrate",
					"performance",
					"wordpress",
					"wordpress-alt",
					"pressthis",
					"update",
					"screenoptions",
					"info",
					"cart",
					"feedback",
					"cloud",
					"translation",
					"tag",
					"category",
					"yes",
					"no",
					"no-alt",
					"plus",
					"minus",
					"dismiss",
					"marker",
					"star-filled",
					"star-half",
					"star-empty",
					"flag",
					"location",
					"location-alt",
					"camera",
					"images-alt",
					"images-alt2",
					"video-alt",
					"video-alt2",
					"video-alt3",
					"vault",
					"shield",
					"shield-alt",
					"search",
					"slides",
					"analytics",
					"chart-pie",
					"chart-bar",
					"chart-line",
					"chart-area",
					"groups",
					"businessman",
					"id",
					"id-alt",
					"products",
					"awards",
					"forms",
					"portfolio",
					"book",
					"book-alt",
					"download",
					"upload",
					"backup",
					"lightbulb",
					"smiley"
				]; 
				options[1] = 'dashicons';
			} else if (options[0] == 'fa') {
				icons = [
					"blank",
					// Mail
					"inbox",
					"envelope",
					"envelope-o",
					"paperclip",
					"reply-all",
					"mail-reply-all",
					"mail-forward",
					"mail-reply",
					"reply",
					// Media
					"music",
					"film",
					"step-backward",
					"fast-backward",
					"backward",
					"play",
					"play-circle",
					"play-circle-o",
					"pause",
					"stop",
					"forward",
					"fast-forward",
					"step-forward",
					"eject",			
					"repeat",
					"refresh",
					"random",			
					"headphones",
					"volume-off",
					"volume-down",
					"volume-up",
					// Arrows
					"angle-double-left",
					"angle-double-right",
					"angle-double-up",
					"angle-double-down",
					"angle-left",
					"angle-right",
					"angle-up",
					"angle-down",
					"arrows",
					"arrow-left",
					"arrow-right",
					"arrow-up",
					"arrow-down",
					"arrows-alt",
					"arrows-v",
					"arrows-h",
					"arrow-circle-left",
					"arrow-circle-right",
					"arrow-circle-up",
					"arrow-circle-down",
					"arrow-circle-o-down",
					"arrow-circle-o-up",
					"arrow-circle-o-right",
					"arrow-circle-o-left",
					"caret-down",
					"caret-up",
					"caret-left",
					"caret-right",
					"chevron-left",
					"chevron-right",
					"chevron-up",
					"chevron-down",
					"chevron-circle-left",
					"chevron-circle-right",
					"chevron-circle-up",
					"chevron-circle-down",
					"expand",
					"compress",
					"hand-o-right",
					"hand-o-left",
					"hand-o-up",
					"hand-o-down",
					"level-up",
					"level-down",
					"long-arrow-down",
					"long-arrow-up",
					"long-arrow-left",
					"long-arrow-right",
					"rotate-right",
					"toggle-left",
					"toggle-down",
					"toggle-up",
					"toggle-right",
					// Search
					"search",
					"search-plus",
					"search-minus",
					// File Editing
					"cut",
					"crop",
					"copy",
					"paste",
					"font",
					"bold",
					"italic",
					"anchor",
					"link",
					"unlink",
					"chain-broken",
					"external-link",
					"external-link-square",
					"text-height",
					"text-width",
					"align-left",
					"align-center",
					"align-right",
					"align-justify",
					"list",
					"quote-left",
					"quote-right",
					"outdent",
					"indent",
					"undo",
					"adjust",
					"tint",
					"edit",
					"list-ul",
					"list-ol",
					"list-alt",
					"th-large",
					"th",
					"th-list",
					"strikethrough",
					"underline",
					"magic",	
					"superscript",
					"subscript",
					"eraser",			
					"pagelines",					
					// Punctuation
					"asterisk",
					"question",
					"info",
					"exclamation",
					// Emoticons
					"smile-o",
					"frown-o",
					"meh-o",
					// Math + Geometry
					"check",
					"times",
					"plus",
					"minus",
					"crosshairs",
					"spinner",
					"circle",
					"circle-o",
					"dot-circle-o",
					"minus-circle",
					"times-circle",
					"check-circle",
					"exclamation-circle",
					"question-circle",
					"info-circle",
					"plus-circle",
					"plus-square",
					"plus-square-o",
					"square",
					"square-o",
					"h-square",
					"share-square",
					"share-square-o",
					"check-square-o",
					"times-circle-o",
					"check-circle-o",
					"ellipsis-h",
					"ellipsis-v",
					"minus-square",
					"check-square",
					"bullseye",
					// Rate
					"thumbs-o-up",
					"thumbs-o-down",
					"star",
					"star-o",
					"star-half",
					"star-half-o",
					"heart",
					"heart-o",
					"lemon-o",
					"trophy",
					"thumbs-up",
					"thumbs-down",			
					// Accounts
					"user",
					"user-md",
					"group",
					"sign-in",			
					"sign-out",
					"key",
					"lock",
					"unlock",
					"unlock-alt",
					"gear",
					"gears",
					"ban",			
					"female",
					"male",	
					"comment",
					"comments",
					"ticket",
					"tasks",
					"calendar",
					"calendar-o",
					// Time
					"sun-o",
					"moon-o",
					"clock-o",			
					// Site	
					"home",	
					"comment-o",
					"comments-o",
					"sitemap",
					// File Operations
					"upload",
					"download",
					"exchange",
					"file-o",
					"files-o",	
					"file",
					"file-text",
					"file-text-o",		
					"folder",
					"folder-o",
					"folder-open",			
					"hdd-o",
					"cloud",
					"cloud-download",
					"cloud-upload",	
					"save",	
					"trash-o",	
					"print",	
					// Social Networks
					"adn",
					"dribbble",
					"dropbox",
					"facebook",
					"facebook-square",
					"flickr",
					"foursquare",
					"github",
					"github-square",
					"github-alt",
					"gittip",
					"google-plus",
					"google-plus-square",
					"instagram",
					"linkedin",
					"linkedin-square",
					"pinterest",
					"pinterest-square",
					"renren",
					"rss",
					"rss-square",
					"skype",
					"stack-exchange",
					"stack-overflow",
					"trello",
					"tumblr",
					"tumblr-square",
					"twitter",
					"twitter-square",
					"retweet",
					"vimeo-square",
					"vk",
					"weibo",
					"xing",
					"xing-square",
					"youtube",
					"youtube-square",
					"youtube-play",
					// Computer			
					"desktop",
					"laptop",
					"tablet",
					"mobile-phone",			
					"phone",			
					"phone-square",		
					"microphone",
					"microphone-slash",	
					"apple",
					"windows",
					"android",
					"linux",
					"html5",
					"css3",			
					"gamepad",
					"keyboard-o",						
					"signal",
					"power-off",
					"terminal",
					"code",			
					"code-fork",
					"bug",
					// Maps
					"glass",
					"globe",
					"map-marker",
					"thumb-tack",
					"building-o",
					"hospital-o",
					"location-arrow",
					"compass",
					"road",			
					// Tools & Objects
					"bell",
					"book",
					"bookmark",
					"bookmark-o",
					"bullhorn",
					"camera",
					"camera-retro",
					"video-camera",
					"picture-o",
					"pencil",
					"pencil-square",
					"flask",			
					"briefcase",
					"table",
					"truck",
					"wrench",
					"plane",			
					"lightbulb-o",			
					"stethoscope",
					"suitcase",
					"bell-o",
					"coffee",			
					"cutlery",
					"umbrella",
					"ambulance",
					"medkit",
					"fighter-jet",
					"beer",
					"wheelchair",		
					"gift",
					"leaf",
					"fire",
					"eye",
					"eye-slash",
					"warning",
					"magnet",
					"flag",
					"flag-o",
					"flag-checkered",
					"fire-extinguisher",
					"rocket",
					"shield",
					"puzzle-piece",
					"legal",
					"dashboard",
					"flash",						
					"bars",
					"bar-chart-o",
					"bed",
					// Sorting
					"columns",
					"filter",
					"sort",
					"sort-down",
					"sort-up",
					"sort-alpha-asc",
					"sort-alpha-desc",
					"sort-amount-asc",
					"sort-amount-desc",
					"sort-numeric-asc",
					"sort-numeric-desc",
					// e-Commerce
					"money",
					"certificate",
					"credit-card",
					"shopping-cart",
					"euro",
					"gbp",
					"dollar",
					"rupee",
					"yen",
					"ruble",
					"won",
					"bitcoin",
					"bitbucket-square",
					"turkish-lira",	
					"tag",
					"tags",
					"qrcode",
					"barcode"
				];
				options[1] = "fa";
			} else if(options[0] == 'icon'){
                icons = [
	                'home',
					'home2',
					'home3',
					'office',
					'newspaper',
					'pencil',
					'pencil2',
					'quill',
					'pen',
					'blog',
					'eyedropper',
					'droplet',
					'paint-format',
					'image',
					'images',
					'camera',
					'headphones',
					'music',
					'play',
					'film',
					'video-camera',
					'dice',
					'pacman',
					'spades',
					'clubs',
					'diamonds',
					'bullhorn',
					'connection',
					'podcast',
					'feed',
					'mic',
					'book',
					'books',
					'library',
					'file-text',
					'profile',
					'file-empty',
					'files-empty',
					'file-text2',
					'file-picture',
					'file-music',
					'file-play',
					'file-video',
					'file-zip',
					'copy',
					'paste',
					'stack',
					'folder',
					'folder-open',
					'folder-plus',
					'folder-minus',
					'folder-download',
					'folder-upload',
					'price-tag',
					'price-tags',
					'barcode',
					'qrcode',
					'ticket',
					'cart',
					'coin-dollar',
					'coin-euro',
					'coin-pound',
					'coin-yen',
					'credit-card',
					'calculator',
					'lifebuoy',
					'phone',
					'phone-hang-up',
					'address-book',
					'envelop',
					'pushpin',
					'location',
					'location2',
					'compass',
					'compass2',
					'map',
					'map2',
					'history',
					'clock',
					'clock2',
					'alarm',
					'bell',
					'stopwatch',
					'calendar',
					'printer',
					'keyboard',
					'display',
					'laptop',
					'mobile',
					'mobile2',
					'tablet',
					'tv',
					'drawer',
					'drawer2',
					'box-add',
					'box-remove',
					'download',
					'upload',
					'floppy-disk',
					'drive',
					'database',
					'undo',
					'redo',
					'undo2',
					'redo2',
					'forward',
					'reply',
					'bubble',
					'bubbles',
					'bubbles2',
					'bubble2',
					'bubbles3',
					'bubbles4',
					'user',
					'users',
					'user-plus',
					'user-minus',
					'user-check',
					'user-tie',
					'quotes-left',
					'quotes-right',
					'hour-glass',
					'spinner',
					'spinner2',
					'spinner3',
					'spinner4',
					'spinner5',
					'spinner6',
					'spinner7',
					'spinner8',
					'spinner9',
					'spinner10',
					'spinner11',
					'binoculars',
					'search',
					'zoom-in',
					'zoom-out',
					'enlarge',
					'shrink',
					'enlarge2',
					'shrink2',
					'key',
					'key2',
					'lock',
					'unlocked',
					'wrench',
					'equalizer',
					'equalizer2',
					'cog',
					'cogs',
					'hammer',
					'magic-wand',
					'aid-kit',
					'bug',
					'pie-chart',
					'stats-dots',
					'stats-bars',
					'stats-bars2',
					'trophy',
					'gift',
					'glass',
					'glass2',
					'mug',
					'spoon-knife',
					'leaf',
					'rocket',
					'meter',
					'meter2',
					'hammer2',
					'fire',
					'lab',
					'magnet',
					'bin',
					'bin2',
					'briefcase',
					'airplane',
					'truck',
					'road',
					'accessibility',
					'target',
					'shield',
					'power',
					'switch',
					'power-cord',
					'clipboard',
					'list-numbered',
					'list',
					'list2',
					'tree',
					'menu',
					'menu2',
					'menu3',
					'menu4',
					'cloud',
					'cloud-download',
					'cloud-upload',
					'cloud-check',
					'download2',
					'upload2',
					'download3',
					'upload3',
					'sphere',
					'earth',
					'link',
					'flag',
					'attachment',
					'eye',
					'eye-plus',
					'eye-minus',
					'eye-blocked',
					'bookmark',
					'bookmarks',
					'sun',
					'contrast',
					'brightness-contrast',
					'star-empty',
					'star-half',
					'star-full',
					'heart',
					'heart-broken',
					'man',
					'woman',
					'man-woman',
					'happy',
					'happy2',
					'smile',
					'smile2',
					'tongue',
					'tongue2',
					'sad',
					'sad2',
					'wink',
					'wink2',
					'grin',
					'grin2',
					'cool',
					'cool2',
					'angry',
					'angry2',
					'evil',
					'evil2',
					'shocked',
					'shocked2',
					'baffled',
					'baffled2',
					'confused',
					'confused2',
					'neutral',
					'neutral2',
					'hipster',
					'hipster2',
					'wondering',
					'wondering2',
					'sleepy',
					'sleepy2',
					'frustrated',
					'frustrated2',
					'crying',
					'crying2',
					'point-up',
					'point-right',
					'point-down',
					'point-left',
					'warning',
					'notification',
					'question',
					'plus',
					'minus',
					'info',
					'cancel-circle',
					'blocked',
					'cross',
					'checkmark',
					'checkmark2',
					'spell-check',
					'enter',
					'exit',
					'play2',
					'pause',
					'stop',
					'previous',
					'next',
					'backward',
					'forward2',
					'play3',
					'pause2',
					'stop2',
					'backward2',
					'forward3',
					'first',
					'last',
					'previous2',
					'next2',
					'eject',
					'volume-high',
					'volume-medium',
					'volume-low',
					'volume-mute',
					'volume-mute2',
					'volume-increase',
					'volume-decrease',
					'loop',
					'loop2',
					'infinite',
					'shuffle',
					'arrow-up-left',
					'arrow-up',
					'arrow-up-right',
					'arrow-right',
					'arrow-down-right',
					'arrow-down',
					'arrow-down-left',
					'arrow-left',
					'arrow-up-left2',
					'arrow-up2',
					'arrow-up-right2',
					'arrow-right2',
					'arrow-down-right2',
					'arrow-down2',
					'arrow-down-left2',
					'arrow-left2',
					'circle-up',
					'circle-right',
					'circle-down',
					'circle-left',
					'tab',
					'move-up',
					'move-down',
					'sort-alpha-asc',
					'sort-alpha-desc',
					'sort-numeric-asc',
					'sort-numberic-desc',
					'sort-amount-asc',
					'sort-amount-desc',
					'command',
					'shift',
					'ctrl',
					'opt',
					'checkbox-checked',
					'checkbox-unchecked',
					'radio-checked',
					'radio-checked2',
					'radio-unchecked',
					'crop',
					'make-group',
					'ungroup',
					'scissors',
					'filter',
					'font',
					'ligature',
					'ligature2',
					'text-height',
					'text-width',
					'font-size',
					'bold',
					'underline',
					'italic',
					'strikethrough',
					'omega',
					'sigma',
					'page-break',
					'superscript',
					'subscript',
					'superscript2',
					'subscript2',
					'text-color',
					'pagebreak',
					'clear-formatting',
					'table',
					'table2',
					'insert-template',
					'pilcrow',
					'ltr',
					'rtl',
					'section',
					'paragraph-left',
					'paragraph-center',
					'paragraph-right',
					'paragraph-justify',
					'indent-increase',
					'indent-decrease',
					'share',
					'new-tab',
					'embed',
					'embed2',
					'terminal',
					'share2',
					'mail',
					'mail2',
					'mail3',
					'mail4',
					'amazon',
					'google',
					'google2',
					'google3',
					'google-plus',
					'google-plus2',
					'google-plus3',
					'hangouts',
					'google-drive',
					'facebook',
					'facebook2',
					'instagram',
					'whatsapp',
					'spotify',
					'telegram',
					'twitter',
					'vine',
					'vk',
					'renren',
					'sina-weibo',
					'rss',
					'rss2',
					'youtube',
					'youtube2',
					'twitch',
					'vimeo',
					'vimeo2',
					'lanyrd',
					'flickr',
					'flickr2',
					'flickr3',
					'flickr4',
					'dribbble',
					'behance',
					'behance2',
					'deviantart',
					'500px',
					'steam',
					'steam2',
					'dropbox',
					'onedrive',
					'github',
					'npm',
					'basecamp',
					'trello',
					'wordpress',
					'joomla',
					'ello',
					'blogger',
					'blogger2',
					'tumblr',
					'tumblr2',
					'yahoo',
					'yahoo2',
					'tux',
					'appleinc',
					'finder',
					'android',
					'windows',
					'windows8',
					'soundcloud',
					'soundcloud2',
					'skype',
					'reddit',
					'hackernews',
					'wikipedia',
					'linkedin',
					'linkedin2',
					'lastfm',
					'lastfm2',
					'delicious',
					'stumbleupon',
					'stumbleupon2',
					'stackoverflow',
					'pinterest',
					'pinterest2',
					'xing',
					'xing2',
					'flattr',
					'foursquare',
					'yelp',
					'paypal',
					'chrome',
					'firefox',
					'IE',
					'edge',
					'safari',
					'opera',
					'file-pdf',
					'file-openoffice',
					'file-word',
					'file-excel',
					'libreoffice',
					'html-five',
					'html-five2',
					'css3',
					'git',
					'codepen',
					'svg',
					'IcoMoon',
                ];
                options[1] = 'icon';
            }else if (options[0] == 'far'){
				icons = [
					"address-book", 
					"address-card", 
					"arrow-alt-circle-down", 
					"arrow-alt-circle-left", 
					"arrow-alt-circle-right", 
					"arrow-alt-circle-up", 
					"bell", 
					"bell-slash", 
					"bookmark", 
					"building", 
					"calendar", 
					"calendar-alt", 
					"calendar-check", 
					"calendar-minus", 
					"calendar-plus", 
					"calendar-times", 
					"caret-square-down", 
					"caret-square-left", 
					"caret-square-right", 
					"caret-square-up", 
					"chart-bar", 
					"check-circle", 
					"check-square", 
					"circle", 
					"clipboard", 
					"clock", 
					"clone", 
					"closed-captioning", 
					"comment", 
					"comment-alt", 
					"comment-dots", 
					"comments", 
					"compass", 
					"copy", 
					"copyright", 
					"credit-card", 
					"dot-circle", 
					"edit", 
					"envelope", 
					"envelope-open", 
					"eye", 
					"eye-slash", 
					"file", 
					"file-alt", 
					"file-archive", 
					"file-audio", 
					"file-code", 
					"file-excel", 
					"file-image", 
					"file-pdf", 
					"file-powerpoint", 
					"file-video", 
					"file-word", 
					"flag", 
					"folder", 
					"folder-open", 
					"font-awesome-logo-full", 
					"frown", 
					"futbol", 
					"gem", 
					"hand-lizard", 
					"hand-paper", 
					"hand-peace", 
					"hand-point-down", 
					"hand-point-left", 
					"hand-point-right", 
					"hand-point-up", 
					"hand-pointer", 
					"hand-rock", 
					"hand-scissors", 
					"hand-spock", 
					"handshake", 
					"hdd", 
					"heart", 
					"hospital", 
					"hourglass", 
					"id-badge", 
					"id-card", 
					"image", 
					"images", 
					"keyboard", 
					"lemon", 
					"life-ring", 
					"lightbulb", 
					"list-alt", 
					"map", 
					"meh", 
					"minus-square", 
					"money-bill-alt", 
					"moon", 
					"newspaper", 
					"object-group", 
					"object-ungroup", 
					"paper-plane", 
					"pause-circle", 
					"play-circle", 
					"plus-square", 
					"question-circle", 
					"registered", 
					"save", 
					"share-square", 
					"smile", 
					"snowflake", 
					"square", 
					"star", 
					"star-half", 
					"sticky-note", 
					"stop-circle", 
					"sun", 
					"thumbs-down", 
					"thumbs-up", 
					"times-circle", 
					"trash-alt", 
					"user", 
					"user-circle", 
					"window-close", 
					"window-maximize", 
					"window-minimize", 
					"window-restore", 
				];
				options[1] = 'fa';
			}else if (options[0] == 'fab'){
				icons = [
					"500px",
					"accessible-icon",
					"accusoft",
					"adn",
					"adversal",
					"affiliatetheme",
					"algolia",
					"amazon",
					"amazon-pay",
					"amilia",
					"android",
					"angellist",
					"angrycreative",
					"angular",
					"app-store",
					"app-store-ios",
					"apper",
					"apple",
					"apple-pay",
					"asymmetrik",
					"audible",
					"autoprefixer",
					"avianex",
					"aviato",
					"aws",
					"bandcamp",
					"behance",
					"behance-square",
					"bimobject",
					"bitbucket",
					"bitcoin",
					"bity",
					"black-tie",
					"blackberry",
					"blogger",
					"blogger-b",
					"bluetooth",
					"bluetooth-b",
					"btc",
					"buromobelexperte",
					"buysellads",
					"cc-amazon-pay",
					"cc-amex",
					"cc-apple-pay",
					"cc-diners-club",
					"cc-discover",
					"cc-jcb",
					"cc-mastercard",
					"cc-paypal",
					"cc-stripe",
					"cc-visa",
					"centercode",
					"chrome",
					"cloudscale",
					"cloudsmith",
					"cloudversify",
					"codepen",
					"codiepie",
					"connectdevelop",
					"contao",
					"cpanel",
					"creative-commons",
					"creative-commons-by",
					"creative-commons-nc",
					"creative-commons-nc-eu",
					"creative-commons-nc-jp",
					"creative-commons-nd",
					"creative-commons-pd",
					"creative-commons-pd-alt",
					"creative-commons-remix",
					"creative-commons-sa",
					"creative-commons-sampling",
					"creative-commons-sampling-plus",
					"creative-commons-share",
					"css3",
					"css3-alt",
					"cuttlefish",
					"d-and-d",
					"dashcube",
					"delicious",
					"deploydog",
					"deskpro",
					"deviantart",
					"digg",
					"digital-ocean",
					"discord",
					"discourse",
					"dochub",
					"docker",
					"draft2digital",
					"dribbble",
					"dribbble-square",
					"dropbox",
					"drupal",
					"dyalog",
					"earlybirds",
					"ebay",
					"edge",
					"elementor",
					"ember",
					"empire",
					"envira",
					"erlang",
					"ethereum",
					"etsy",
					"expeditedssl",
					"facebook",
					"facebook-f",
					"facebook-messenger",
					"facebook-square",
					"firefox",
					"first-order",
					"first-order-alt",
					"firstdraft",
					"flickr",
					"flipboard",
					"fly",
					"font-awesome",
					"font-awesome-alt",
					"font-awesome-flag",
					"font-awesome-logo-full",
					"fonticons",
					"fonticons-fi",
					"fort-awesome",
					"fort-awesome-alt",
					"forumbee",
					"foursquare",
					"free-code-camp",
					"freebsd",
					"fulcrum",
					"galactic-republic",
					"galactic-senate",
					"get-pocket",
					"gg",
					"gg-circle",
					"git",
					"git-square",
					"github",
					"github-alt",
					"github-square",
					"gitkraken",
					"gitlab",
					"gitter",
					"glide",
					"glide-g",
					"gofore",
					"goodreads",
					"goodreads-g",
					"google",
					"google-drive",
					"google-play",
					"google-plus",
					"google-plus-g",
					"google-plus-square",
					"google-wallet",
					"gratipay",
					"grav",
					"gripfire",
					"grunt",
					"gulp",
					"hacker-news",
					"hacker-news-square",
					"hips",
					"hire-a-helper",
					"hooli",
					"hotjar",
					"houzz",
					"html5",
					"hubspot",
					"imdb",
					"instagram",
					"internet-explorer",
					"ioxhost",
					"itunes",
					"itunes-note",
					"java",
					"jedi-order",
					"jenkins",
					"joget",
					"joomla",
					"js",
					"js-square",
					"jsfiddle",
					"keybase",
					"keycdn",
					"kickstarter",
					"kickstarter-k",
					"korvue",
					"laravel",
					"lastfm",
					"lastfm-square",
					"leanpub",
					"less",
					"line",
					"linkedin",
					"linkedin-in",
					"linode",
					"linux",
					"lyft",
					"magento",
					"mandalorian",
					"mastodon",
					"maxcdn",
					"medapps",
					"medium",
					"medium-m",
					"medrt",
					"meetup",
					"microsoft",
					"mix",
					"mixcloud",
					"mizuni",
					"modx",
					"monero",
					"napster",
					"nintendo-switch",
					"node",
					"node-js",
					"npm",
					"ns8",
					"nutritionix",
					"odnoklassniki",
					"odnoklassniki-square",
					"old-republic",
					"opencart",
					"openid",
					"opera",
					"optin-monster",
					"osi",
					"page4",
					"pagelines",
					"palfed",
					"patreon",
					"paypal",
					"periscope",
					"phabricator",
					"phoenix-framework",
					"phoenix-squadron",
					"php",
					"pied-piper",
					"pied-piper-alt",
					"pied-piper-hat",
					"pied-piper-pp",
					"pinterest",
					"pinterest-p",
					"pinterest-square",
					"playstation",
					"product-hunt",
					"pushed",
					"python",
					"qq",
					"quinscape",
					"quora",
					"r-project",
					"ravelry",
					"react",
					"readme",
					"rebel",
					"red-river",
					"reddit",
					"reddit-alien",
					"reddit-square",
					"rendact",
					"renren",
					"replyd",
					"researchgate",
					"resolving",
					"rocketchat",
					"rockrms",
					"safari",
					"sass",
					"schlix",
					"scribd",
					"searchengin",
					"sellcast",
					"sellsy",
					"servicestack",
					"shirtsinbulk",
					"simplybuilt",
					"sistrix",
					"sith",
					"skyatlas",
					"skype",
					"slack",
					"slack-hash",
					"slideshare",
					"snapchat",
					"snapchat-ghost",
					"snapchat-square",
					"soundcloud",
					"speakap",
					"spotify",
					"stack-exchange",
					"stack-overflow",
					"staylinked",
					"steam",
					"steam-square",
					"steam-symbol",
					"sticker-mule",
					"strava",
					"stripe",
					"stripe-s",
					"studiovinari",
					"stumbleupon",
					"stumbleupon-circle",
					"superpowers",
					"supple",
					"teamspeak",
					"telegram",
					"telegram-plane",
					"tencent-weibo",
					"themeisle",
					"trade-federation",
					"trello",
					"tripadvisor",
					"tumblr",
					"tumblr-square",
					"twitch",
					"twitter",
					"twitter-square",
					"typo3",
					"uber",
					"uikit",
					"uniregistry",
					"untappd",
					"usb",
					"ussunnah",
					"vaadin",
					"viacoin",
					"viadeo",
					"viadeo-square",
					"viber",
					"vimeo",
					"vimeo-square",
					"vimeo-v",
					"vine",
					"vk",
					"vnv",
					"vuejs",
					"weibo",
					"weixin",
					"whatsapp",
					"whatsapp-square",
					"whmcs",
					"wikipedia-w",
					"windows",
					"wolf-pack-battalion",
					"wordpress",
					"wordpress-simple",
					"wpbeginner",
					"wpexplorer",
					"wpforms",
					"xbox",
					"xing",
					"xing-square",
					"y-combinator",
					"yahoo",
					"yandex",
					"yandex-international",
					"yelp",
					"yoast",
					"youtube",
					"youtube-square",
				];
				options[1] = 'fa';
			}else if (options[0] == 'fas'){
				icons = [
					"address-book", 
					"address-card", 
					"adjust", 
					"align-center", 
					"align-justify", 
					"align-left", 
					"align-right", 
					"allergies", 
					"ambulance", 
					"american-sign-language-interpreting", 
					"anchor", 
					"angle-double-down", 
					"angle-double-left", 
					"angle-double-right", 
					"angle-double-up", 
					"angle-down", 
					"angle-left", 
					"angle-right", 
					"angle-up", 
					"archive", 
					"arrow-alt-circle-down", 
					"arrow-alt-circle-left", 
					"arrow-alt-circle-right", 
					"arrow-alt-circle-up", 
					"arrow-circle-down", 
					"arrow-circle-left", 
					"arrow-circle-right", 
					"arrow-circle-up", 
					"arrow-down", 
					"arrow-left", 
					"arrow-right", 
					"arrow-up", 
					"arrows-alt", 
					"arrows-alt-h", 
					"arrows-alt-v", 
					"assistive-listening-systems", 
					"asterisk", 
					"at", 
					"audio-description", 
					"backward", 
					"balance-scale", 
					"ban", 
					"band-aid", 
					"barcode", 
					"bars", 
					"baseball-ball", 
					"basketball-ball", 
					"bath", 
					"battery-empty", 
					"battery-full", 
					"battery-half", 
					"battery-quarter", 
					"battery-three-quarters", 
					"bed", 
					"beer", 
					"bell", 
					"bell-slash", 
					"bicycle", 
					"binoculars", 
					"birthday-cake", 
					"blind", 
					"bold", 
					"bolt", 
					"bomb", 
					"book", 
					"bookmark", 
					"bowling-ball", 
					"box", 
					"box-open", 
					"boxes", 
					"braille", 
					"briefcase", 
					"briefcase-medical", 
					"bug", 
					"building", 
					"bullhorn", 
					"bullseye", 
					"burn", 
					"bus", 
					"calculator", 
					"calendar", 
					"calendar-alt", 
					"calendar-check", 
					"calendar-minus", 
					"calendar-plus", 
					"calendar-times", 
					"camera", 
					"camera-retro", 
					"capsules", 
					"car", 
					"caret-down", 
					"caret-left", 
					"caret-right", 
					"caret-square-down", 
					"caret-square-left", 
					"caret-square-right", 
					"caret-square-up", 
					"caret-up", 
					"cart-arrow-down", 
					"cart-plus", 
					"certificate", 
					"chart-area", 
					"chart-bar", 
					"chart-line", 
					"chart-pie", 
					"check", 
					"check-circle", 
					"check-square", 
					"chess", 
					"chess-bishop", 
					"chess-board", 
					"chess-king", 
					"chess-knight", 
					"chess-pawn", 
					"chess-queen", 
					"chess-rook", 
					"chevron-circle-down", 
					"chevron-circle-left", 
					"chevron-circle-right", 
					"chevron-circle-up", 
					"chevron-down", 
					"chevron-left", 
					"chevron-right", 
					"chevron-up", 
					"child", 
					"circle", 
					"circle-notch", 
					"clipboard", 
					"clipboard-check", 
					"clipboard-list", 
					"clock", 
					"clone", 
					"closed-captioning", 
					"cloud", 
					"cloud-download-alt", 
					"cloud-upload-alt", 
					"code", 
					"code-branch", 
					"coffee", 
					"cog", 
					"cogs", 
					"columns", 
					"comment", 
					"comment-alt", 
					"comment-dots", 
					"comment-slash", 
					"comments", 
					"compass", 
					"compress", 
					"copy", 
					"copyright", 
					"couch", 
					"credit-card", 
					"crop", 
					"crosshairs", 
					"cube", 
					"cubes", 
					"cut", 
					"database", 
					"deaf", 
					"desktop", 
					"diagnoses", 
					"dna", 
					"dollar-sign", 
					"dolly", 
					"dolly-flatbed", 
					"donate", 
					"dot-circle", 
					"dove", 
					"download", 
					"edit", 
					"eject", 
					"ellipsis-h", 
					"ellipsis-v", 
					"envelope", 
					"envelope-open", 
					"envelope-square", 
					"eraser", 
					"euro-sign", 
					"exchange-alt", 
					"exclamation", 
					"exclamation-circle", 
					"exclamation-triangle", 
					"expand", 
					"expand-arrows-alt", 
					"external-link-alt", 
					"external-link-square-alt", 
					"eye", 
					"eye-dropper", 
					"eye-slash", 
					"fast-backward", 
					"fast-forward", 
					"fax", 
					"female", 
					"fighter-jet", 
					"file", 
					"file-alt", 
					"file-archive", 
					"file-audio", 
					"file-code", 
					"file-excel", 
					"file-image", 
					"file-medical", 
					"file-medical-alt", 
					"file-pdf", 
					"file-powerpoint", 
					"file-video", 
					"file-word", 
					"film", 
					"filter", 
					"fire", 
					"fire-extinguisher", 
					"first-aid", 
					"flag", 
					"flag-checkered", 
					"flask", 
					"folder", 
					"folder-open", 
					"font", 
					"font-awesome-logo-full", 
					"football-ball", 
					"forward", 
					"frown", 
					"futbol", 
					"gamepad", 
					"gavel", 
					"gem", 
					"genderless", 
					"gift", 
					"glass-martini", 
					"globe", 
					"golf-ball", 
					"graduation-cap", 
					"h-square", 
					"hand-holding", 
					"hand-holding-heart", 
					"hand-holding-usd", 
					"hand-lizard", 
					"hand-paper", 
					"hand-peace", 
					"hand-point-down", 
					"hand-point-left", 
					"hand-point-right", 
					"hand-point-up", 
					"hand-pointer", 
					"hand-rock", 
					"hand-scissors", 
					"hand-spock", 
					"hands", 
					"hands-helping", 
					"handshake", 
					"hashtag", 
					"hdd", 
					"heading", 
					"headphones", 
					"heart", 
					"heartbeat", 
					"history", 
					"hockey-puck", 
					"home", 
					"hospital", 
					"hospital-alt", 
					"hospital-symbol", 
					"hourglass", 
					"hourglass-end", 
					"hourglass-half", 
					"hourglass-start", 
					"i-cursor", 
					"id-badge", 
					"id-card", 
					"id-card-alt", 
					"image", 
					"images", 
					"inbox", 
					"indent", 
					"industry", 
					"info", 
					"info-circle", 
					"italic", 
					"key", 
					"keyboard", 
					"language", 
					"laptop", 
					"leaf", 
					"lemon", 
					"level-down-alt", 
					"level-up-alt", 
					"life-ring", 
					"lightbulb", 
					"link", 
					"lira-sign", 
					"list", 
					"list-alt", 
					"list-ol", 
					"list-ul", 
					"location-arrow", 
					"lock", 
					"lock-open", 
					"long-arrow-alt-down", 
					"long-arrow-alt-left", 
					"long-arrow-alt-right", 
					"long-arrow-alt-up", 
					"low-vision", 
					"magic", 
					"magnet", 
					"male", 
					"map", 
					"map-marker", 
					"map-marker-alt", 
					"map-pin", 
					"map-signs", 
					"mars", 
					"mars-double", 
					"mars-stroke", 
					"mars-stroke-h", 
					"mars-stroke-v", 
					"medkit", 
					"meh", 
					"mercury", 
					"microchip", 
					"microphone", 
					"microphone-slash", 
					"minus", 
					"minus-circle", 
					"minus-square", 
					"mobile", 
					"mobile-alt", 
					"money-bill-alt", 
					"moon", 
					"motorcycle", 
					"mouse-pointer", 
					"music", 
					"neuter", 
					"newspaper", 
					"notes-medical", 
					"object-group", 
					"object-ungroup", 
					"outdent", 
					"paint-brush", 
					"pallet", 
					"paper-plane", 
					"paperclip", 
					"parachute-box", 
					"paragraph", 
					"paste", 
					"pause", 
					"pause-circle", 
					"paw", 
					"pen-square", 
					"pencil-alt", 
					"people-carry", 
					"percent", 
					"phone", 
					"phone-slash", 
					"phone-square", 
					"phone-volume", 
					"piggy-bank", 
					"pills", 
					"plane", 
					"play", 
					"play-circle", 
					"plug", 
					"plus", 
					"plus-circle", 
					"plus-square", 
					"podcast", 
					"poo", 
					"portrait", 
					"pound-sign", 
					"power-off", 
					"prescription-bottle", 
					"prescription-bottle-alt", 
					"print", 
					"procedures", 
					"puzzle-piece", 
					"qrcode", 
					"question", 
					"question-circle", 
					"quidditch", 
					"quote-left", 
					"quote-right", 
					"random", 
					"recycle", 
					"redo", 
					"redo-alt", 
					"registered", 
					"reply", 
					"reply-all", 
					"retweet", 
					"ribbon", 
					"road", 
					"rocket", 
					"rss", 
					"rss-square", 
					"ruble-sign", 
					"rupee-sign", 
					"save", 
					"search", 
					"search-minus", 
					"search-plus", 
					"seedling", 
					"server", 
					"share", 
					"share-alt", 
					"share-alt-square", 
					"share-square", 
					"shekel-sign", 
					"shield-alt", 
					"ship", 
					"shipping-fast", 
					"shopping-bag", 
					"shopping-basket", 
					"shopping-cart", 
					"shower", 
					"sign", 
					"sign-in-alt", 
					"sign-language", 
					"sign-out-alt", 
					"signal", 
					"sitemap", 
					"sliders-h", 
					"smile", 
					"smoking", 
					"snowflake", 
					"sort", 
					"sort-alpha-down", 
					"sort-alpha-up", 
					"sort-amount-down", 
					"sort-amount-up", 
					"sort-down", 
					"sort-numeric-down", 
					"sort-numeric-up", 
					"sort-up", 
					"space-shuttle", 
					"spinner", 
					"square", 
					"square-full", 
					"star", 
					"star-half", 
					"step-backward", 
					"step-forward", 
					"stethoscope", 
					"sticky-note", 
					"stop", 
					"stop-circle", 
					"stopwatch", 
					"street-view", 
					"strikethrough", 
					"subscript", 
					"subway", 
					"suitcase", 
					"sun", 
					"superscript", 
					"sync", 
					"sync-alt", 
					"syringe", 
					"table", 
					"table-tennis", 
					"tablet", 
					"tablet-alt", 
					"tablets", 
					"tachometer-alt", 
					"tag", 
					"tags", 
					"tape", 
					"tasks", 
					"taxi", 
					"terminal", 
					"text-height", 
					"text-width", 
					"th", 
					"th-large", 
					"th-list", 
					"thermometer", 
					"thermometer-empty", 
					"thermometer-full", 
					"thermometer-half", 
					"thermometer-quarter", 
					"thermometer-three-quarters", 
					"thumbs-down", 
					"thumbs-up", 
					"thumbtack", 
					"ticket-alt", 
					"times", 
					"times-circle", 
					"tint", 
					"toggle-off", 
					"toggle-on", 
					"trademark", 
					"train", 
					"transgender", 
					"transgender-alt", 
					"trash", 
					"trash-alt", 
					"tree", 
					"trophy", 
					"truck", 
					"truck-loading", 
					"truck-moving", 
					"tty", 
					"tv", 
					"umbrella", 
					"underline", 
					"undo", 
					"undo-alt", 
					"universal-access", 
					"university", 
					"unlink", 
					"unlock", 
					"unlock-alt", 
					"upload", 
					"user", 
					"user-alt", 
					"user-alt-slash", 
					"user-astronaut", 
					"user-check", 
					"user-circle", 
					"user-clock", 
					"user-cog", 
					"user-edit", 
					"user-friends", 
					"user-graduate", 
					"user-lock", 
					"user-md", 
					"user-minus", 
					"user-ninja", 
					"user-plus", 
					"user-secret", 
					"user-shield", 
					"user-slash", 
					"user-tag", 
					"user-tie", 
					"user-times", 
					"users", 
					"users-cog", 
					"utensil-spoon", 
					"utensils", 
					"venus", 
					"venus-double", 
					"venus-mars", 
					"vial", 
					"vials", 
					"video", 
					"video-slash", 
					"volleyball-ball", 
					"volume-down", 
					"volume-off", 
					"volume-up", 
					"warehouse", 
					"weight", 
					"wheelchair", 
					"wifi", 
					"window-close", 
					"window-maximize", 
					"window-minimize", 
					"window-restore", 
					"wine-glass", 
					"won-sign", 
					"wrench", 
					"x-ray", 
					"yen-sign", 
				];
				options[1] = 'fa';
			}else if (options[0] == 'lnr'){
				icons = [
					"home",
					"apartment",
					"pencil",
					"magic-wand",
					"drop",
					"lighter",
					"poop",
					"sun",
					"moon",
					"cloud",
					"cloud-upload",
					"cloud-download",
					"cloud-sync",
					"cloud-check",
					"database",
					"lock",
					"cog",
					"trash",
					"dice",
					"heart",
					"star",
					"star-half",
					"star-empty",
					"flag",
					"envelope",
					"paperclip",
					"inbox",
					"eye",
					"printer",
					"file-empty",
					"file-add",
					"enter",
					"exit",
					"graduation-hat",
					"license",
					"music-note",
					"film-play",
					"camera-video",
					"camera",
					"picture",
					"book",
					"bookmark",
					"user",
					"users",
					"shirt",
					"store",
					"cart",
					"tag",
					"phone-handset",
					"phone",
					"pushpin",
					"map-marker",
					"map",
					"location",
					"calendar-full",
					"keyboard",
					"spell-check",
					"screen",
					"smartphone",
					"tablet",
					"laptop",
					"laptop-phone",
					"power-switch",
					"bubble",
					"heart-pulse",
					"construction",
					"pie-chart",
					"chart-bars",
					"gift",
					"diamond",
					"linearicons",
					"dinner",
					"coffee-cup",
					"leaf",
					"paw",
					"rocket",
					"briefcase",
					"bus",
					"car",
					"train",
					"bicycle",
					"wheelchair",
					"select",
					"earth",
					"smile",
					"sad",
					"neutral",
					"mustache",
					"alarm",
					"bullhorn",
					"volume-high",
					"volume-medium",
					"volume-low",
					"volume",
					"mic",
					"hourglass",
					"undo",
					"redo",
					"sync",
					"history",
					"clock",
					"download",
					"upload",
					"enter-down",
					"exit-up",
					"bug",
					"code",
					"link",
					"unlink",
					"thumbs-up",
					"thumbs-down",
					"magnifier",
					"cross",
					"menu",
					"list",
					"chevron-up",
					"chevron-down",
					"chevron-left",
					"chevron-right",
					"arrow-up",
					"arrow-down",
					"arrow-left",
					"arrow-right",
					"move",
					"warning",
					"question-circle",
					"menu-circle",
					"checkmark-circle",
					"cross-circle",
					"plus-circle",
					"circle-minus",
					"arrow-up-circle",
					"arrow-down-circle",
					"arrow-left-circle",
					"arrow-right-circle",
					"chevron-up-circle",
					"chevron-down-circle",
					"chevron-left-circle",
					"chevron-right-circle",
					"crop",
					"frame-expand",
					"frame-contract",
					"layers",
					"funnel",
					"text-format",
					"text-format-remove",
					"text-size",
					"bold",
					"italic",
					"underline",
					"strikethrough",
					"highlight",
					"text-align-left",
					"text-align-center",
					"text-align-right",
					"text-align-justify",
					"line-spacing",
					"indent-increase",
					"indent-decrease",
					"pilcrow",
					"direction-ltr",
					"direction-rtl",
					"page-break",
					"sort-alpha-asc",
					"sort-amount-asc",
					"hand",
					"pointer-up",
					"pointer-right",
					"pointer-down",
					"pointer-left"
				];
				options[1] = 'lnr';
			}else if (options[0] == 'genericon '){
				icons = [
					"standard",
				"aside",
				"image",
				"gallery",
				"video",
				"status",
				"quote",
				"link",
				"chat",
				"audio",

				/* Social icons */
				"github",
				"dribbble",
				"twitter",
				"facebook",
				"facebook-alt",
				"wordpress",
				"googleplus",
				"linkedin",
				"linkedin-alt",
				"pinterest",
				"pinterest-alt",
				"flickr",
				"vimeo",
				"youtube",
				"tumblr",
				"instagram",
				"codepen",
				"polldaddy",
				"googleplus-alt",
				"path",
				"skype",
				"digg",
				"reddit",
				"stumbleupon",
				"pocket",

				/* Meta icons */
				"comment",
				"category",
				"tag",
				"time",
				"user",
				"day",
				"week",
				"month",
				"pinned",

				/* Other icons */
				"search",
				"unzoom",
				"zoom",
				"show",
				"hide",
				"close",
				"close-alt",
				"trash",
				"star",
				"home",
				"mail",
				"edit",
				"reply",
				"feed",
				"warning",
				"share",
				"attachment",
				"location",
				"checkmark",
				"menu",
				"refresh",
				"minimize",
				"maximize",
				"404",
				"spam",
				"summary",
				"cloud",
				"key",
				"dot",
				"next",
				"previous",
				"expand",
				"collapse",
				"dropdown",
				"dropdown-left",
				"top",
				"draggable",
				"phone",
				"send-to-phone",
				"plugin",
				"cloud-download",
				"cloud-upload",
				"external",
				"document",
				"book",
				"cog",
				"unapprove",
				"cart",
				"pause",
				"stop",
				"skip-back",
				"skip-ahead",
				"play",
				"tablet",
				"send-to-tablet",
				"info",
				"notice",
				"help",
				"fastforward",
				"rewind",
				"portfolio",
				"heart",
				"code",
				"subscribe",
				"unsubscribe",
				"subscribed",
				"reply-alt",
				"reply-single",
				"flag",
				"print",
				"lock",
				"bold",
				"italic",
				"picture",
				/* Generic shapes */
				"uparrow",
				"rightarrow",
				"downarrow",
				"leftarrow",
				"genericon-videocamera",
				"genericon-rating-empty"
				];
				options[1] = 'genericon';
			}else if (options[0] == 'linecon'){
				icons = [
				"heart2","cloud2","star","tv2","video","sound","trash","user2","key3","search2",
				"settings","camera2","tag","lock2","bulb","pen2","diamond","display2","location3",
				"eye2","bubble3","stack2","cup","phone2","news","mail5","like","photo","note","clock3",
				"paperplane","params","banknote","data","music2","megaphone","study",
				"lab2","food","t-shirt","fire2","clip","shop","calendar2","wallet",
				"vynil","truck2","world",
				];
				options[1] = 'linecon';
			}else if(options[0] == 'ti'){
				icons = [
					"arrow-up",
					"arrow-right",
					"arrow-left",
					"arrow-down",
					"arrows-vertical",
					"arrows-horizontal",
					"angle-up",
					"angle-right",
					"angle-left",
					"angle-down",
					"angle-double-up",
					"angle-double-right",
					"angle-double-left",
					"angle-double-down",
					"move",
					"fullscreen",
					"arrow-top-right",
					"arrow-top-left",
					"arrow-circle-up",
					"arrow-circle-right",
					"arrow-circle-left",
					"arrow-circle-down",
					"arrows-corner",
					"split-v",
					"split-v-alt",
					"split-h",
					"hand-point-up",
					"hand-point-right",
					"hand-point-left",
					"hand-point-down",
					"back-right",
					"back-left",
					"exchange-vertical",
					"wand",
					"save",
					"save-alt",
					"direction",
					"direction-alt",
					"user",
					"link",
					"unlink",
					"trash",
					"target",
					"tag",
					"desktop",
					"tablet",
					"mobile",
					"email",
					"star",
					"spray",
					"signal",
					"shopping-cart",
					"shopping-cart-full",
					"settings",
					"search",
					"zoom-in",
					"zoom-out",
					"cut",
					"ruler",
					"ruler-alt-2",
					"ruler-pencil",
					"ruler-alt",
					"bookmark",
					"bookmark-alt",
					"reload",
					"plus",
					"minus",
					"close",
					"pin",
					"pencil",
					"pencil-alt",
					"paint-roller",
					"paint-bucket",
					"na",
					"medall",
					"medall-alt",
					"marker",
					"marker-alt",
					"lock",
					"unlock",
					"location-arrow",
					"layout",
					"layers",
					"layers-alt",
					"key",
					"image",
					"heart",
					"heart-broken",
					"hand-stop",
					"hand-open",
					"hand-drag",
					"flag",
					"flag-alt",
					"flag-alt-2",
					"eye",
					"import",
					"export",
					"cup",
					"crown",
					"comments",
					"comment",
					"comment-alt",
					"thought",
					"clip",
					"check",
					"check-box",
					"camera",
					"announcement",
					"brush",
					"brush-alt",
					"palette",
					"briefcase",
					"bolt",
					"bolt-alt",
					"blackboard",
					"bag",
					"world",
					"wheelchair",
					"car",
					"truck",
					"timer",
					"ticket",
					"thumb-up",
					"thumb-down",
					"stats-up",
					"stats-down",
					"shine",
					"shift-right",
					"shift-left",
					"shift-right-alt",
					"shift-left-alt",
					"shield",
					"notepad",
					"server",
					"pulse",
					"printer",
					"power-off",
					"plug",
					"pie-chart",
					"panel",
					"package",
					"music",
					"music-alt",
					"mouse",
					"mouse-alt",
					"money",
					"microphone",
					"menu",
					"menu-alt",
					"map",
					"map-alt",
					"location-pin",
					"light-bulb",
					"info",
					"infinite",
					"id-badge",
					"hummer",
					"home",
					"help",
					"headphone",
					"harddrives",
					"harddrive",
					"gift",
					"game",
					"filter",
					"files",
					"file",
					"zip",
					"folder",
					"envelope",
					"dashboard",
					"cloud",
					"cloud-up",
					"cloud-down",
					"clipboard",
					"calendar",
					"book",
					"bell",
					"basketball",
					"bar-chart",
					"bar-chart-alt",
					"archive",
					"anchor",
					"alert",
					"alarm-clock",
					"agenda",
					"write",
					"wallet",
					"video-clapper",
					"video-camera",
					"vector",
					"support",
					"stamp",
					"slice",
					"shortcode",
					"receipt",
					"pin2",
					"pin-alt",
					"pencil-alt2",
					"eraser",
					"more",
					"more-alt",
					"microphone-alt",
					"magnet",
					"line-double",
					"line-dotted",
					"line-dashed",
					"ink-pen",
					"info-alt",
					"help-alt",
					"headphone-alt",
					"gallery",
					"face-smile",
					"face-sad",
					"credit-card",
					"comments-smiley",
					"time",
					"share",
					"share-alt",
					"rocket",
					"new-window",
					"rss",
					"rss-alt",
					"control-stop",
					"control-shuffle",
					"control-play",
					"control-pause",
					"control-forward",
					"control-backward",
					"volume",
					"control-skip-forward",
					"control-skip-backward",
					"control-record",
					"control-eject",
					"paragraph",
					"uppercase",
					"underline",
					"text",
					"Italic",
					"smallcap",
					"list",
					"list-ol",
					"align-right",
					"align-left",
					"align-justify",
					"align-center",
					"quote-right",
					"quote-left",
					"layout-width-full",
					"layout-width-default",
					"layout-width-default-alt",
					"layout-tab",
					"layout-tab-window",
					"layout-tab-v",
					"layout-tab-min",
					"layout-slider",
					"layout-slider-alt",
					"layout-sidebar-right",
					"layout-sidebar-none",
					"layout-sidebar-left",
					"layout-placeholder",
					"layout-menu",
					"layout-menu-v",
					"layout-menu-separated",
					"layout-menu-full",
					"layout-media-right",
					"layout-media-right-alt",
					"layout-media-overlay",
					"layout-media-overlay-alt",
					"layout-media-overlay-alt-2",
					"layout-media-left",
					"layout-media-left-alt",
					"layout-media-center",
					"layout-media-center-alt",
					"layout-list-thumb",
					"layout-list-thumb-alt",
					"layout-list-post",
					"layout-list-large-image",
					"layout-line-solid",
					"layout-grid4",
					"layout-grid3",
					"layout-grid2",
					"layout-grid2-thumb",
					"layout-cta-right",
					"layout-cta-left",
					"layout-cta-center",
					"layout-cta-btn-right",
					"layout-cta-btn-left",
					"layout-column4",
					"layout-column3",
					"layout-column2",
					"layout-accordion-separated",
					"layout-accordion-merged",
					"layout-accordion-list",
					"widgetized",
					"widget",
					"widget-alt",
					"view-list",
					"view-list-alt",
					"view-grid",
					"upload",
					"download",
					"loop",
					"layout-sidebar-2",
					"layout-grid4-alt",
					"layout-grid3-alt",
					"layout-grid2-alt",
					"layout-column4-alt",
					"layout-column3-alt",
					"layout-column2-alt",
					"flickr",
					"flickr-alt",
					"instagram",
					"google",
					"github",
					"facebook",
					"dropbox",
					"dropbox-alt",
					"dribbble",
					"apple",
					"android",
					"yahoo",
					"trello",
					"stack-overflow",
					"soundcloud",
					"sharethis",
					"sharethis-alt",
					"reddit",
					"microsoft",
					"microsoft-alt",
					"linux",
					"jsfiddle",
					"joomla",
					"html5",
					"css3",
					"drupal",
					"wordpress",
					"tumblr",
					"tumblr-alt",
					"skype",
					"youtube",
					"vimeo",
					"vimeo-alt",
					"twitter",
					"twitter-alt",
					"linkedin",
					"pinterest",
					"pinterest-alt",
					"themify-logo",
					"themify-favicon",
					"themify-favicon-alt"
				];
				options[1] = "ti";
			}else {
				icons = [
					"blank",
					"standard",
					"aside",
					"image",
					"gallery",
					"video",
					"status",
					"quote",
					"link",
					"chat",
					"audio",

					/* Social icons */
					"github",
					"dribbble",
					"twitter",
					"facebook",
					"facebook-alt",
					"wordpress",
					"googleplus",
					"linkedin",
					"linkedin-alt",
					"pinterest",
					"pinterest-alt",
					"flickr",
					"vimeo",
					"youtube",
					"tumblr",
					"instagram",
					"codepen",
					"polldaddy",
					"googleplus-alt",
					"path",
					"skype",
					"digg",
					"reddit",
					"stumbleupon",
					"pocket",

					/* Meta icons */
					"comment",
					"category",
					"tag",
					"time",
					"user",
					"day",
					"week",
					"month",
					"pinned",

					/* Other icons */
					"search",
					"unzoom",
					"zoom",
					"show",
					"hide",
					"close",
					"close-alt",
					"trash",
					"star",
					"home",
					"mail",
					"edit",
					"reply",
					"feed",
					"warning",
					"share",
					"attachment",
					"location",
					"checkmark",
					"menu",
					"refresh",
					"minimize",
					"maximize",
					"404",
					"spam",
					"summary",
					"cloud",
					"key",
					"dot",
					"next",
					"previous",
					"expand",
					"collapse",
					"dropdown",
					"dropdown-left",
					"top",
					"draggable",
					"phone",
					"send-to-phone",
					"plugin",
					"cloud-download",
					"cloud-upload",
					"external",
					"document",
					"book",
					"cog",
					"unapprove",
					"cart",
					"pause",
					"stop",
					"skip-back",
					"skip-ahead",
					"play",
					"tablet",
					"send-to-tablet",
					"info",
					"notice",
					"help",
					"fastforward",
					"rewind",
					"portfolio",
					"heart",
					"code",
					"subscribe",
					"unsubscribe",
					"subscribed",
					"reply-alt",
					"reply-single",
					"flag",
					"print",
					"lock",
					"bold",
					"italic",
					"picture",

					/* Generic shapes */
					"uparrow",
					"rightarrow",
					"downarrow",
					"leftarrow"
				];
				options[1] = 'genericon';
			};
		};
		font_set();

		function build_list($popup,$button,clear) {
			$list = $popup.find('.icon-picker-list');
	  if (clear==1) { $list.empty(); // clear list //
	  }
	  for (var i in icons) {
	  	// if(options[0] == 'md'){
	  	// 	$list.append('<li data-icon="'+icons[i]+'"><a href="#" title="'+icons[i]+'"><span class="material-icons">'+icons[i]+'</span></a></li>');	
	  	// }else 
	  	if(options[0] == 'eleganticons'){
	  		$list.append('<li data-icon="'+icons[i]+'"><a href="#" title="'+icons[i]+'"><span class="'+options[0]+' '+icons[i]+'"></span></a></li>');	
	  	}
	  	else{
	  		if(options[0] == "icon"){
	  			$classess = "wpmega-icommon";
	  		}else{
	  			$classess = "wpmega-other";
	  		}
	  		$list.append('<li class="'+$classess+'" data-icon="'+icons[i]+'"><a href="#" title="'+icons[i]+'"><span class="'+options[0]+' '+options[1]+'-'+icons[i]+'"></span></a></li>');	
	  	}
	  };
	  $('a', $list).click(function(e) {
	  	e.preventDefault();
	  	var title = $(this).attr("title");
	  	$target.val(options[0]+"|"+options[1]+"-"+title);

	  	// if(options[0] == 'md'){
	  	// 	$button.html('');
	  	// 	$button.removeClass().addClass("button icon-picker").append('<span class="material-icons">'+title+'</span>').siblings('.icon-picker-input').val('material-icons|'+title);
	  	// }else 
	  	if(options[0] == 'eleganticons'){
	  		$button.html('');
	  		$button.removeClass().addClass("button icon-picker "+options[0]+" "+title).siblings('.icon-picker-input').val(options[0]+'|'+title);
	  	}else{
	  		$button.html('');
	  		$button.removeClass().addClass("button icon-picker "+options[0]+" "+options[1]+"-"+title).siblings('.icon-picker-input').val(options[0]+"|"+options[1]+"-"+title);
	  	}
	  	removePopup();
	  });
	};
	
	function removePopup(){
		$(".icon-picker-container").remove();
	}
	

	$button = $('.icon-picker');
	$button.each( function() {
		$(this).on('click.iconPicker', function() {
			createPopup($(this));
		});
	});


	function createPopup($button) {
		$target = $($button.data('target'));
		$popup = $('<div class="icon-picker-container"> \
			<span class="icon-picker-close"><i class="dashicons dashicons-no"></i></span> \
			<div class="icon-picker-control"> \
			</div>\
                        <ul class="icon-picker-list" /> \
			</div>')
		.css({
			'top': $button.offset().top,
			'left': $button.offset().left
		});
		build_list($popup,$button,0);
		var $control = $popup.find('.icon-picker-control');
		$control.html('<p>Select Font: <select><option value="dashicons">Dashicons</option><option value="linecon">Linecons</option><option value="fa">Font Awesome 4.7.0</option><optgroup label="Font Awesome 5.x"><option value="fab">Brands</option><option value="far">Regular</option><option value="fas">Solid</option></optgroup><option value="genericon">Genericons</option><option value="icon">Icomoon</option><option value="lnr">Linearicons</option><option value="ti">Themify</option></select></p>'+
			'<a data-direction="back" href="#"><span class="dashicons dashicons-arrow-left-alt2"></span></a> '+
			'<input type="text" class="" placeholder="Search" />'+
			'<a data-direction="forward" href="#"><span class="dashicons dashicons-arrow-right-alt2"></span></a>'+
			'');

		$('select', $control).on('change', function(e) {
			e.preventDefault();
			if (this.value != options[0]) {
				options[0] = this.value;
				font_set();
				build_list($popup,$button,1);
			};
		});

		$('a', $control).click(function(e) {
			e.preventDefault();
			if ($(this).data('direction') === 'back') {
						//move last 25 elements to front
						$('li:gt(' + (icons.length - 26) + ')', $list).each(function() {
							$(this).prependTo($list);
						});
					} else {
						//move first 25 elements to the end
						$('li:lt(25)', $list).each(function() {
							$(this).appendTo($list);
						});
					}
				});

		$popup.appendTo('body').show();

		$('input', $control).on('keyup', function(e) {
			var search = $(this).val();
			if (search === '') {
						//show all again
						$('li:lt(25)', $list).show();
					} else {
						$('li', $list).each(function() {
							if ($(this).data('icon').toString().toLowerCase().indexOf(search.toLowerCase()) !== -1) {
								$(this).show();
							} else {
								$(this).hide();
							}
						});
					}
				});

		$(document).mouseup(function (e){
			if (!$popup.is(e.target) && $popup.has(e.target).length === 0) {
				removePopup();
			}
		});

		$(document).on("click",".icon-picker-close",function(e){ 
			removePopup();
		});

		$(document).on('keydown',function(e){
			if (e.keyCode === 27) {
				removePopup();
			}
		});
	}
}

$(function() {

	/** Icon picker Initialization For Menu & Custom Template **/
       //$('.icon-picker').iconPicker();                  
   });

}(jQuery));
